<?php

use Illuminate\Database\Seeder;

use App\Repositories\Models\Menus;

class MenusSeeder extends Seeder
{

    protected $menuList = [
        [
            'menu_name' => 'page_index',
            'title' => '平台首页',
            'menu_path' => '#',
            'parent_id' => -1,
            'menu_type' => 'top',
            'menu_icon' => 'md-home',
            'component' => '',
            'status' => 1,
            'is_show' => 1,
            'sys_default' => 1,
            'sort' => 1.0,
            'created_by' => 0,
            'created_at' => '',
            'updated_at' => '',
            'children' => [
                [
                'menu_name' => 'sys_manager',
                'title' => '系统管理',
                'menu_path' => '#',
                'parent_id' => 0,
                'menu_type' => 'page',
                'menu_icon' => 'ios-settings',
                'component' => 'Main',
                'status' => 1,
                'is_show' => 1,
                'sys_default' => 1,
                'sort' => 1.0,
                'created_by' => 0,
                'created_at' => '',
                'updated_at' => ''
                    ]
            ],
        ],

        [
            'menu_name' => 'page_doc',
            'title' => '物料中心',
            'menu_path' => '#',
            'parent_id' => -1,
            'menu_type' => 'top',
            'menu_icon' => 'md-book',
            'component' => '',
            'status' => 1,
            'is_show' => 1,
            'sys_default' => 1,
            'sort' => 1.0,
            'created_by' => 0,
            'created_at' => '',
            'updated_at' => '',
            'children' => [
                [
                'menu_name' => 'doc_manage',
                'title' => '文档管理',
                'menu_path' => '/doc-manage',
                'parent_id' => 0,
                'menu_type' => 'page',
                'menu_icon' => 'md-albums',
                'component' => 'Main',
                'status' => 1,
                'is_show' => 1,
                'sys_default' => 1,
                'sort' => 1.11,
                'created_by' => 0,
                'created_at' => '',
                'updated_at' => ''
                    ]
            ],
        ],

    ];

    protected $subMenusList = [
        'sys_manager' =>
            [
                [
                    'menu_name' => 'menu_permission',
                    'title' => '菜单权限管理',
                    'menu_path' => '/menus',
                    'parent_id' => 0,
                    'menu_type' => 'page',
                    'menu_icon' => 'md-menu',
                    'component' => 'sys/menu-manage/menuManage',
                    'status' => 1,
                    'is_show' => 1,
                    'sys_default' => 1,
                    'sort' => 1.10,
                    'created_by' => 0,
                    'created_at' => '',
                    'updated_at' => ''
                ],
                [
                    'menu_name' => 'role_permission',
                    'title' => '用户权限管理',
                    'menu_path' => '/permission',
                    'parent_id' => 0,
                    'menu_type' => 'page',
                    'menu_icon' => 'md-contacts',
                    'component' => 'sys/role-manage/roleManage',
                    'status' => 1,
                    'is_show' => 1,
                    'sys_default' => 1,
                    'sort' => 1.11,
                    'created_by' => 0,
                    'created_at' => '',
                    'updated_at' => ''
                ],
                [
                    'menu_name' => 'user_manage',
                    'title' => '用户管理',
                    'menu_path' => '/user-manage',
                    'parent_id' => 0,
                    'menu_type' => 'page',
                    'menu_icon' => 'md-person',
                    'component' => 'sys/user-manage/userManage',
                    'status' => 1,
                    'is_show' => 1,
                    'sys_default' => 1,
                    'sort' => 1.11,
                    'created_by' => 0,
                    'created_at' => '',
                    'updated_at' => ''
                ],
            ],
        'doc_manage' =>
            [
                [
                    'menu_name' => 'sys_doc',
                    'title' => '系统文档',
                    'menu_path' => '/doc-manage',
                    'parent_id' => 0,
                    'menu_type' => 'page',
                    'menu_icon' => 'ios-document',
                    'component' => 'doc/doc-manage/docManage',
                    'status' => 1,
                    'is_show' => 1,
                    'sys_default' => 1,
                    'sort' => 1.11,
                    'created_by' => 0,
                    'created_at' => '',
                    'updated_at' => ''
                ],
            ]
    ];


    public function run()
    {
        foreach($this->menuList as $menu){
            $menu['created_at'] = date('Y-m-d H:i:s',time());
            $menu['updated_at'] = date('Y-m-d H:i:s',time());

            $childrenItem = $menu['children'];
            unset($menu['children']);

            $id = Menus::query()->insertGetId($menu);
            if(isset($childrenItem) && !empty($childrenItem)){
                foreach($childrenItem as $children){
                    $children['parent_id'] = $id;
                    $children['created_at'] = date('Y-m-d H:i:s',time());
                    $children['updated_at'] = date('Y-m-d H:i:s',time());

                    $childrenId = Menus::query()->insertGetId($children);

                    if(isset($this->subMenusList[$children['menu_name']]) && !empty($this->subMenusList[$children['menu_name']])){
                        collect($this->subMenusList[$children['menu_name']])->map(function($subMenus) use ($childrenId){
                            $subMenus['parent_id'] = $childrenId;
                            $subMenus['created_at'] = date('Y-m-d H:i:s',time());
                            $subMenus['updated_at'] = date('Y-m-d H:i:s',time());

                            Menus::query()->insertGetId($subMenus);
                        });
                    }
                }
            }
        }
    }
}
